#ifndef __IUF_SHIP
#define __IUF_SHIP
/** This class represent the user spaceship.
Please note the specialized redraw function and all 
the function to start and stop the thrust and the rotation 
of the ship. \\
{\large Version History}
\begin{description}
\item[0.1] First Release.
\item[0.1s]
Changed the interface between the GameSession and Ship Classes 
when a ship fires Instead of returning a pointer to the bullet that has fired 
the function add the new bullets to the passed container.
\item[0.2s]
Added member functions for managing side movements 
and booleans to store the state of the side engines.
\end{description}
*/
class Ship : public GameObj
{
 public:
/** Ship Constructor.
	With respect to the GameObj constructor it 
	initialize accelleration, engine flag and number of active bullet.
	*/
	Ship();
	/// Acceleration of the ship (mt/sec^2)
	Point3f a;
	/// To know if the engine is on
	bool thrust;
/// To know if the left engine is on
	bool lthrust;
/// To know if the right engine is on
	bool rthrust;

	/** Ship version of the GameObj::Update().
	It modifies the velocity according to the 
	current acceleration */
	void Update(int t)
	{ 
		Point3f na;
		a=Point3f(0,0,0);
		if(thrust){
			na=VDir();
			na*=20.0;
			a+=na;
		}
		if(lthrust){
			na=VDir();
			na*=20.0;
			na=RotateZ(na,float(M_PI/2));
			a+=na;
		}
		if(rthrust){
			na=VDir();
			na*=20.0;
			na=RotateZ(na,float(-M_PI/2));
			a+=na;
		}
		v += (t/1000.0f*a);
		GameObj::Update(t);
	}

  /// Start the Thrust of the ship accellerating it
	void ThrustOn() { 
		thrust=true;
	}
	/// Stop the Thrust of the ship (accelleration = 0)
	void ThrustOff(){
		thrust=false;
		}

	/// Start the left strafing of ship 
	void StartStrafeLeft(){lthrust=true;}
	/// Start the right strafing  of ship 
	void StartStrafeRight(){rthrust=true;}
	/// Stop the left strafing of ship 
	void StopStrafeLeft(){lthrust=false;}
	/// Stop the right strafing of ship 
	void StopStrafeRight(){rthrust=false;}

	/// Start the left rotation of ship 
	void StartLeft(){av=180.0;}
	/// Start the right rotation of ship 
	void StartRight(){av=-180.0;}
	/// Stop the left rotation of ship 
	void StopLeft(){av=0.0;}
	/// Stop the right rotation of ship 
	void StopRight(){av=0.0;}
	int Draw();
	
	/// Return the maximum number of bullet currently available for this ship
	int MaxBullet() {return 10;};
	
	void TerminateBullet(){ActiveBullet--;};

	/// Shoot a new bullet creating the object
	virtual void Shoot(list<Bullet *> &LB) {
		if(ActiveBullet < MaxBullet()){
			ActiveBullet++;
			Bullet *bb =new Bullet(p,angle,v+VDir()*30);
			LB.push_back(bb);
		}
	}
	protected:
		/// The number of active Bullet of this ship
		int ActiveBullet; 
};
#endif